#include <stdio.h>
#include <stdlib.h>
//#include <string.h>
//#include <def21266.h>
#include "functions.h"
#include "Initialize.h"
#include "MIDI/PlayEgn.h"
//#include "MIDI/W56964_Driver.c"
#include "RPG_Driver.h"


/* Default Buffer Length */
#define HIDE_CURSOR 4
#define NEW_LINE 13
#define CLEAR_LCD 12

#define EXTRAM 0x1200000
#define EXTMIDI 0x1800000


/* Main code section */
main(){
               //           unsigned char ch = 0xFF;
              
   
              
   int i, nRet = 0, ctr = 0, rctr = 0, lctr = 0, currMenu = 0, NoOpts = 0, level = 0, numOpts = 0;
   extern int right,left,select,back;
   char ** temp;
   
   // The complier reserves space in the declaration, so all the menus
   // needed to be 40 characters to correspond to the two lines 
   // they would be printed on
   char * mainMenu[4] = {"  Image Processing                      ",
     "   IMS Processing                       ",
     "  Play a MIDI file                      ",
     "   LCD Formatting                       "};
   
   char *LCDsubs[2] = {"  Adjust Contrast                       ",
     "  Adjust Backlight                      "};

   char * subMenu[3] = {"   Select an Image                      ",
     "    Select an IMS                       ",
     "  Select a MIDI file                    "};  
  
   // This is where I append the menu strings to include the 
   // various characters I want them to display on the second line
   // this is why the second index is >20

   mainMenu[0][25] = 0x90; //single eigth note
   mainMenu[0][26] = 0x91; //double eigth note
   mainMenu[0][27] = 0x90; 
   mainMenu[0][28] = 0x20;
   mainMenu[0][29] = 0xdf; //right arrow
   mainMenu[0][30] = 0x20;
   mainMenu[0][31] = 0x30; //0
   mainMenu[0][32] = 0x31; //1
   mainMenu[0][33] = 0x30; //0
   mainMenu[0][34] = 0x31; //1
   mainMenu[0][35] = 0;
   
   mainMenu[1][25] = 0x30; //0
   mainMenu[1][26] = 0x31; //1
   mainMenu[1][27] = 0x30; //0
   mainMenu[1][28] = 0x31; //1
   mainMenu[1][29] = 0x20;
   mainMenu[1][30] = 0xdf; //right arrow
   mainMenu[1][31] = 0x20;
   mainMenu[1][32] = 0x2e; //.
   mainMenu[1][33] = 0x6d; //m
   mainMenu[1][34] = 0x69; //i
   mainMenu[1][35] = 0x64; //d 
   mainMenu[1][36] = 0;
   
   mainMenu[2][25] = 0x91;
   mainMenu[2][26] = 0x20;
   mainMenu[2][27] = 0x90;
   mainMenu[2][28] = 0x20;
   mainMenu[2][29] = 0x91;
   mainMenu[2][30] = 0x20;
   mainMenu[2][31] = 0x90;
   mainMenu[2][32] = 0x20;
   mainMenu[2][33] = 0x91;
   mainMenu[2][34] = 0;
   
   mainMenu[3][25] = 0xfa; //left bracket
   mainMenu[3][26] = 0xc4; //underscore
   mainMenu[3][27] = 0xc4;
   mainMenu[3][28] = 0xc4;
   mainMenu[3][29] = 0xc4;
   mainMenu[3][30] = 0xc4;
   mainMenu[3][31] = 0xc4;
   mainMenu[3][32] = 0xc4;
   mainMenu[3][33] = 0xfc; //right bracket
   mainMenu[3][34] = 0;
     
   LCDsubs[0][27] = 0xd6; 
   LCDsubs[0][28] = 0xd7;
   LCDsubs[0][29] = 0xd8;
   LCDsubs[0][30] = 0xd9;
   LCDsubs[0][30] = 0xda;
   LCDsubs[0][31] = 0;
   
   LCDsubs[1][25] = 0x24;   
   LCDsubs[1][26] = 0x20;
   LCDsubs[1][27] = 0x24;
   LCDsubs[1][28] = 0x20;
   LCDsubs[1][29] = 0x24;
   LCDsubs[1][30] = 0x20;
   LCDsubs[1][31] = 0x24;
   LCDsubs[1][32] = 0x20;
   LCDsubs[1][33] = 0x24;
   LCDsubs[1][34] = 0;

  init();
  interrupt(SIG_DAIH,DAIroutine);
  outchar(HIDE_CURSOR);

  outchar(CLEAR_LCD);
  
  //Main welcome Screen
  print("     The Digital    "); 
  print(" Sheet Music Reader ");
  print("  ");
  outchar(0x90);
  print("  ");
  print("and Player");
  print("  ");
  outchar(0x90);
  print("       ");
  outchar(0x91);
  print("   ");
  outchar(0x90);
  print("   "); 
  outchar(0x91);

  //wait till select is pushed
  while (select == 0){ }
  select = 0;
 
  MainMenuTemplate();
  
  temp = mainMenu;
  numOpts = 3;
  NoOpts = 0;
  currMenu = 0;
  level = 0;
  printMenu(temp[currMenu]);
  
while(1){ // Polls through the 4 user input options (right, left, select, back)
    
  if (left == 1){// Scrolls left if there are options to scroll
    lctr++;
    left=0;
      if (lctr == 2){
        lctr = 0;
        left = 0;
        if (NoOpts == 1){
        }
        else if (currMenu == 0){
          currMenu = numOpts;
          printMenu(temp[numOpts]);
        }
        else{
          currMenu--;
          printMenu(temp[currMenu]);
        }
      }  
  }
   
  else if (right == 1){ //scrolls right if there are options to scroll
    rctr++;
    right=0;
      if (rctr == 2){
        rctr = 0;
        right = 0;
        if (NoOpts == 1){
        }
        else if (currMenu == numOpts){
          currMenu = 0;         
          printMenu(temp[0]);
        }
        else{
          currMenu++;
          printMenu(temp[currMenu]); 
        }    
      }
  }

  ///////////////////////////////////////////
  //
  //  Checks if there is a select button hit
  //
  ///////////////////////////////////////////
  
  else if (select == 1){ 
    select = 0;

    if (level == 0){ // Level of menu //
      level = 1;
      
      MenuTemplate();

      if (currMenu == 3){
        level = 2;
        //want to go to LCD submenu options
        temp = LCDsubs;
        numOpts = 1;
        currMenu = 0;
        printMenu(temp[currMenu]);
      }
      else if (currMenu == 0) {
        NoOpts = 1;
        printMenu(subMenu[0]);
      }
      else if (currMenu == 1) {
        NoOpts = 1;
        printMenu(subMenu[1]);
      }
      else if (currMenu == 2) {
        NoOpts = 1;
        printMenu(subMenu[2]);
      }

    }

    else if (level == 1){

     //Function calls to handle various file selection tasks

    }

    else if (level == 2){
      //Checks which LCD format to call  
      if (currMenu == 0){
        AdjustContrast();
      }
      else if(currMenu == 1){
        AdjustBacklight();
      }
      
      back = 0;
      select = 0;
      level = 2; /* stay in same level after returning from function */
      MenuTemplate();
      printMenu(LCDsubs[currMenu]);

    }   
    
  }
  
///////////////////////////////////////////
//
//  Checks if there is a back button hit
//
///////////////////////////////////////////

  else if (back == 1) {
    back = 0;
    
    if (level == 0){
    }
    else if (level == 1){
      NoOpts = 0;
      level = 0;
      temp = mainMenu;
      numOpts = 3;
      MainMenuTemplate();
      printMenu(mainMenu[currMenu]);
    }
    else if (level == 2){
      level = 0;
      NoOpts = 0;
      temp = mainMenu;
      numOpts = 3;
      currMenu = 3;
      MainMenuTemplate();
      printMenu(mainMenu[currMenu]);
    }
  }



} // End of Menu Polling loop.

} 
//////////////////////////////////////////////////////
//
// Function for printing the menu on the middle two lines
//
///////////////////////////////////////////////////////
void printMenu(char message[])
{
    outchar(0x110001);
    print("                                        ");
    outchar(0x110001); 
    print(message);
}

////////////////////////////////////////////////////////
//
//  Contrast & Backlight functions, adjust value based
//    on rotating RPG
//
////////////////////////////////////////////////////////
void AdjustContrast(void)
{
  extern int back, right,left;
  int val = 50, i,rctr = 0,lctr = 0;
  char str[10];
  LCDMenuTemplate();
  printMenu("Adjusting Contrast  Current Value = 50");
  *(volatile int *)TXSPI=(0x0F00 | val); 
  
  while (1){
    
    if (left == 1){
      lctr++;
      left=0;
        if (lctr == 2){
          lctr = 0;
          left = 0;
          if (val == 0){
            
          }
          else{
            val--;
            i = sprintf(str, "%d", val);
           *(volatile int *)TXSPI=(0x0F00 | val);
                  
            if (val == 99){    
            outchar(0x00080808); // Backspace three spaces
            print(str);
            }
            else if (val < 10) {     
            outchar(0x00000808); // Backspace two spaces
            print(" ");  // Print a space
            print(str);
            }
            else {     
            outchar(0x00000808); // Backspace two spaces
            print(str);
            }
          }
        }  
    }
   
    if (right == 1){
      rctr++;
      right=0;
        if (rctr == 2){
          rctr = 0;
          right = 0;
          if (val == 100){
              
          }
          else{
            val++;
            i = sprintf(str, "%d", val);
            *(volatile int *)TXSPI=(0x0F00 | val);
             
            if (val < 10) {     
              outchar(0x00000808); // Backspace two spaces
              print(" "); // Print a space
              print(str);
            }
            else {     
              outchar(0x00000808); // Backspace two spaces
              print(str);
            }
          }    
        } 
    }
    if (back == 1){
    back = 0;
    return;  
    }
  }
  
}


void AdjustBacklight(void)
{
  extern int back, right,left;
  int val = 50, i,rctr = 0,lctr = 0;
  char str[10];
  LCDMenuTemplate();
  printMenu("Adjusting Backlight  Current Value = 50");
  *(volatile int *)TXSPI=(0x0E00 | val);
  
  while (1){
    
    if (left == 1){
      lctr++;
      left=0;
        if (lctr == 2){
          lctr = 0;
          left = 0;
          if (val == 0){

          }
          else{
            val--;
            i = sprintf(str, "%d", val);
           *(volatile int *)TXSPI=(0x0E00 | val);  
            
            if (val == 99){    
            outchar(0x00080808); // Backspace three spaces
            print(str);
            }
            else if (val < 10) {     
            outchar(0x00000808); // Backspace two spaces
            print(" ");
            print(str);
            }
            else {     
            outchar(0x00000808); // Backspace two spaces
            print(str);
            }
        
          }
        }  
    }
   
    if (right == 1){
      rctr++;
      right=0;
        if (rctr == 2){
          rctr = 0;
          right = 0;
          if (val == 100){
              
          }
          else{
            val++;
            i = sprintf(str, "%d", val);
            *(volatile int *)TXSPI=(0x0E00 | val);
            
            if (val < 10) {     
              outchar(0x00000808); // Backspace two spaces
              print(" ");
              print(str);
            }
            else {     
              outchar(0x00000808); // Backspace two spaces
              print(str);
            }
          }    
        }
    }
    if (back == 1){
      back = 0;
      return;
    }
  }
  
}
/////////////////////////////////////////////////////
//
// Functions to print the top and bottom line
//   vary depending on where in the menu you are
//
//////////////////////////////////////////////////////
void MainMenuTemplate(void)
{
    int w;
  outchar(0x0ce1);
  print("   "); 
  print("More Options");
  print("   ");
  outchar(0xdf110003);
  print(" ");
  for(w=0; w<65000; w++){
    w=w;
  } 
  outchar(0xfa);
  print("Select");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}

void MenuTemplate(void)
{
    int w;
  outchar(0x0ce1);
  print("   "); 
  print("More Options");
  print("   ");
  outchar(0xdf110003);
  print(" ");
  outchar(0x20fa);
  print("Select");
  outchar(0xfc);
  print("    ");
  outchar(0xfa);
  print("Back");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}
void LCDMenuTemplate(void)
{
  int w;
  outchar(0x0ce1);
  print("   "); 
  print("Change Value");
  print("   ");
  outchar(0xdf110003);
  print("             ");
  outchar(0xfa);
  print("Back");
  outchar(0xfc);
  for(w=0; w<65000; w++){
    w=w;
  }
}


